=== Interaction/Widgets/CMakeLists.txt ===
set(classes
  vtk3DCursorRepresentation
  vtk3DCursorWidget
  vtk3DWidget
  vtkAbstractPolygonalHandleRepresentation3D
  vtkAbstractSplineRepresentation
  vtkAbstractWidget
  vtkAffineRepresentation
  vtkAffineRepresentation2D
  vtkAffineWidget
  vtkAngleRepresentation
  vtkAngleRepresentation2D
  vtkAngleRepresentation3D
  vtkAngleWidget
  vtkAxesTransformRepresentation
  vtkAxesTransformWidget
  vtkBalloonRepresentation
  vtkBalloonWidget
  vtkBezierContourLineInterpolator
  vtkBiDimensionalRepresentation
  vtkBiDimensionalRepresentation2D
  vtkBiDimensionalWidget
  vtkBorderRepresentation
  vtkBorderWidget
  vtkBoundedPlanePointPlacer
  vtkBoxRepresentation
  vtkBoxWidget
  vtkBoxWidget2
  vtkBrokenLineWidget
  vtkButtonRepresentation
  vtkButtonWidget
  vtkCamera3DRepresentation
  vtkCamera3DWidget
  vtkCameraHandleSource
  vtkCameraOrientationWidget
  vtkCameraOrientationRepresentation
  vtkCameraPathRepresentation
  vtkCameraPathWidget
  vtkCameraRepresentation
  vtkCameraWidget
  vtkCaptionRepresentation
  vtkCaptionWidget
  vtkCellCentersPointPlacer
  vtkCenteredSliderRepresentation
  vtkCenteredSliderWidget
  vtkCheckerboardRepresentation
  vtkCheckerboardWidget
  vtkClosedSurfacePointPlacer
  vtkCompassRepresentation
  vtkCompassWidget
  vtkConstrainedPointHandleRepresentation
  vtkContinuousValueWidget
  vtkContinuousValueWidgetRepresentation
  vtkContourLineInterpolator
  vtkContourRepresentation
  vtkContourWidget
  vtkCoordinateFrameRepresentation
  vtkCoordinateFrameWidget
  vtkCurveRepresentation
  vtkDijkstraImageContourLineInterpolator
  vtkDisplaySizedImplicitPlaneWidget
  vtkDisplaySizedImplicitPlaneRepresentation
  vtkDistanceRepresentation
  vtkDistanceRepresentation2D
  vtkDistanceRepresentation3D
  vtkDistanceWidget
  vtkEllipsoidTensorProbeRepresentation
  vtkEqualizerContextItem
  vtkEvent
  vtkFinitePlaneRepresentation
  vtkFinitePlaneWidget
  vtkFixedSizeHandleRepresentation3D
  vtkFocalPlaneContourRepresentation
  vtkFocalPlanePointPlacer
  vtkHandleRepresentation
  vtkHandleWidget
  vtkHoverWidget
  vtkImageActorPointPlacer
  vtkImageCroppingRegionsWidget
  vtkImageOrthoPlanes
  vtkImagePlaneWidget
  vtkImageTracerWidget
  vtkImplicitCylinderRepresentation
  vtkImplicitCylinderWidget
  vtkImplicitImageRepresentation
  vtkImplicitPlaneRepresentation
  vtkImplicitPlaneWidget
  vtkImplicitPlaneWidget2
  vtkLightRepresentation
  vtkLightWidget
  vtkLinearContourLineInterpolator
  vtkLineRepresentation
  vtkLineWidget
  vtkLineWidget2
  vtkLogoRepresentation
  vtkLogoWidget
  vtkMagnifierRepresentation
  vtkMagnifierWidget
  vtkMeasurementCubeHandleRepresentation3D
  vtkOrientationMarkerWidget
  vtkOrientationRepresentation
  vtkOrientationWidget
  vtkOrientedGlyphContourRepresentation
  vtkOrientedGlyphFocalPlaneContourRepresentation
  vtkOrientedPolygonalHandleRepresentation3D
  vtkParallelopipedRepresentation
  vtkParallelopipedWidget
  vtkPlaneWidget
  vtkPlaybackRepresentation
  vtkPlaybackWidget
  vtkPointCloudRepresentation
  vtkPointCloudWidget
  vtkPointHandleRepresentation2D
  vtkPointHandleRepresentation3D
  vtkPointPlacer
  vtkPointWidget
  vtkPolyDataContourLineInterpolator
  vtkPolyDataPointPlacer
  vtkPolyDataSourceWidget
  vtkPolygonalHandleRepresentation3D
  vtkPolygonalSurfaceContourLineInterpolator
  vtkPolygonalSurfacePointPlacer
  vtkPolyLineRepresentation
  vtkPolyLineWidget
  vtkProgressBarRepresentation
  vtkProgressBarWidget
  vtkProp3DButtonRepresentation
  vtkRectilinearWipeRepresentation
  vtkRectilinearWipeWidget
  vtkResliceCursor
  vtkResliceCursorActor
  vtkResliceCursorLineRepresentation
  vtkResliceCursorPicker
  vtkResliceCursorPolyDataAlgorithm
  vtkResliceCursorRepresentation
  vtkResliceCursorThickLineRepresentation
  vtkResliceCursorWidget
  vtkScalarBarRepresentation
  vtkScalarBarWidget
  vtkSeedRepresentation
  vtkSeedWidget
  vtkSliderRepresentation
  vtkSliderRepresentation2D
  vtkSliderRepresentation3D
  vtkSliderWidget
  vtkSphereHandleRepresentation
  vtkSphereRepresentation
  vtkSphereWidget
  vtkSphereWidget2
  vtkSplineRepresentation
  vtkSplineWidget
  vtkSplineWidget2
  vtkTensorProbeRepresentation
  vtkTensorProbeWidget
  vtkTensorRepresentation
  vtkTensorWidget
  vtkTerrainContourLineInterpolator
  vtkTerrainDataPointPlacer
  vtkTextRepresentation
  vtkTexturedButtonRepresentation
  vtkTexturedButtonRepresentation2D
  vtkTextWidget
  vtkWidgetCallbackMapper
  vtkWidgetEvent
  vtkWidgetEventTranslator
  vtkWidgetRepresentation
  vtkWidgetSet
  vtkXYPlotWidget
  )

vtk_module_add_module(VTK::InteractionWidgets
  CLASSES ${classes})
vtk_add_test_mangling(VTK::InteractionWidgets)
