=== IO/NetCDF/Testing/Python/CMakeLists.txt ===
vtk_add_test_python(
  NetCDFCF2DBounds.py
  NetCDFCFSetOutputType.py
  NetCDFCFSphericalCoords.py
  NetCDFCFUnstructured.py
  NetCDFReader.py
  )
